3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11 or: $dashless [--quiet] init [--] [<path>...]
12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--[no-]single-branch] [--] [<path>...]
14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15 or: $dashless [--quiet] set-url [--] <path> <newurl>
16 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
17 or: $dashless [--quiet] foreach [--recursive] <command>
18 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
25 wt_prefix=$(git rev-parse --show-prefix)
28 # Tell the rest of git that any URLs we get don't come
29 # directly from the user, so it can apply policy as appropriate.
30 GIT_PROTOCOL_FROM_USER=0
31 export GIT_PROTOCOL_FROM_USER
56 if test "$1" = "#unmatched"
63 # Print a submodule configuration setting
69 # Checks in the usual git-config places first (for overrides),
70 # otherwise it falls back on .gitmodules. This allows you to
71 # distribute project-wide defaults in .gitmodules, while still
72 # customizing individual repositories if necessary. If the option is
73 # not in .gitmodules either, print a default value.
75 get_submodule_config () {
79 value=$(git config submodule."$name"."$option")
82 value=$(git submodule--helper config submodule."$name"."$option")
84 printf '%s' "${value:-$default}"
89 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
92 # Given a full hex object ID, is this the zero OID?
94 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
97 # Sanitize the local git environment for use within a submodule. We
98 # can't simply use clear_local_git_env since we want to preserve some
99 # of the settings from GIT_CONFIG_PARAMETERS.
100 sanitize_submodule_env()
102 save_config=$GIT_CONFIG_PARAMETERS
104 GIT_CONFIG_PARAMETERS=$save_config
105 export GIT_CONFIG_PARAMETERS
109 # Add a new submodule to the working tree, .gitmodules and the index
113 # optional branch is stored in global branch variable
117 # parse $args after "submodule ... add".
123 case "$2" in '') usage ;; esac
137 case "$2" in '') usage ;; esac
142 reference_path="${1#--reference=}"
148 case "$2" in '') usage ;; esac
153 case "$2" in '') usage ;; esac
174 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
176 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
179 if test -n "$reference_path"
181 is_absolute_path "$reference_path" ||
182 reference_path="$wt_prefix$reference_path"
184 reference="--reference=$reference_path"
190 if test -z "$sm_path"; then
191 sm_path=$(printf '%s\n' "$repo" |
192 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
195 if test -z "$repo" || test -z "$sm_path"; then
199 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
201 # assure repo is absolute or relative to parent
204 test -z "$wt_prefix" ||
205 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
207 # dereference source url relative to parent's url
208 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
215 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
220 # multiple //; leading ./; /./; /../; trailing /
221 sm_path=$(printf '%s/\n' "$sm_path" |
233 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
234 die "$(eval_gettext "'\$sm_path' already exists in the index")"
236 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
237 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
240 if test -d "$sm_path" &&
241 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
243 git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
244 die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
249 dryerr=$(git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" 2>&1 >/dev/null)
258 if test -n "$custom_name"
260 sm_name="$custom_name"
265 if ! git submodule--helper check-name "$sm_name"
267 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
270 # perhaps the path exists and is already a git repo, else clone it
271 if test -e "$sm_path"
273 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
275 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
277 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
281 if test -d ".git/modules/$sm_name"
285 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
286 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
287 die "$(eval_gettextln "\
288 If you want to reuse this local git directory instead of cloning again from
290 use the '--force' option. If the local git directory is not the correct repo
291 or you are unsure what this means choose another name with the '--name' option.")"
293 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
296 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
298 sanitize_submodule_env
300 # ash fails to wordsplit ${branch:+-b "$branch"...}
302 '') git checkout -f -q ;;
303 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
305 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
307 git config submodule."$sm_name".url "$realrepo"
309 git add --no-warn-embedded-repo $force "$sm_path" ||
310 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
312 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
313 git submodule--helper config submodule."$sm_name".url "$repo" &&
316 git submodule--helper config submodule."$sm_name".branch "$branch"
318 git add --force .gitmodules ||
319 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
321 # NEEDSWORK: In a multi-working-tree world, this needs to be
322 # set in the per-worktree config.
323 if git config --get submodule.active >/dev/null
325 # If the submodule being adding isn't already covered by the
326 # current configured pathspec, set the submodule's active flag
327 if ! git submodule--helper is-active "$sm_path"
329 git config submodule."$sm_name".active "true"
332 git config submodule."$sm_name".active "true"
337 # Execute an arbitrary command sequence in each checked out
340 # $@ = command to execute
344 # parse $args after "submodule ... foreach".
364 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
368 # Register submodules in .git/config
370 # $@ = requested paths (default to all)
374 # parse $args after "submodule ... init".
395 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
399 # Unregister submodules from .git/config and remove their work tree
403 # parse $args after "submodule ... deinit".
431 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
434 is_tip_reachable () (
435 sanitize_submodule_env &&
437 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
441 fetch_in_submodule () (
442 sanitize_submodule_env &&
449 git fetch $(get_default_remote) "$@" ;;
454 # Update each submodule path to correct revision, using clone and checkout as needed
456 # $@ = requested paths (default to all)
460 # parse $args after "submodule ... update".
493 case "$2" in '') usage ;; esac
494 reference="--reference=$2"
513 recommend_shallow="--recommend-shallow"
515 --no-recommend-shallow)
516 recommend_shallow="--no-recommend-shallow"
519 case "$2" in '') usage ;; esac
527 case "$2" in '') usage ;; esac
535 single_branch="--single-branch"
538 single_branch="--no-single-branch"
556 cmd_init "--" "$@" || return
560 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
561 ${progress:+"--progress"} \
562 ${wt_prefix:+--prefix "$wt_prefix"} \
563 ${prefix:+--recursive-prefix "$prefix"} \
564 ${update:+--update "$update"} \
565 ${reference:+"$reference"} \
566 ${dissociate:+"--dissociate"} \
567 ${depth:+--depth "$depth"} \
568 ${require_init:+--require-init} \
573 "$@" || echo "#unmatched" $?
576 while read -r quickabort sha1 just_cloned sm_path
578 die_if_unmatched "$quickabort" "$sha1"
580 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
582 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
584 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
586 if test $just_cloned -eq 1
590 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
591 git rev-parse --verify HEAD) ||
592 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
597 branch=$(git submodule--helper remote-branch "$sm_path")
598 if test -z "$nofetch"
600 # Fetch remote before determining tracking $sha1
601 fetch_in_submodule "$sm_path" $depth ||
602 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
604 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
605 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
606 git rev-parse --verify "${remote_name}/${branch}") ||
607 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
610 if test "$subsha1" != "$sha1" || test -n "$force"
613 # If we don't already have a -f flag and the submodule has never been checked out
614 if test -z "$subsha1" && test -z "$force"
619 if test -z "$nofetch"
621 # Run fetch only if $sha1 isn't present or it
622 # is not reachable from a ref.
623 is_tip_reachable "$sm_path" "$sha1" ||
624 fetch_in_submodule "$sm_path" $depth ||
625 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
627 # Now we tried the usual fetch, but $sha1 may
628 # not be reachable from any of the refs
629 is_tip_reachable "$sm_path" "$sha1" ||
630 fetch_in_submodule "$sm_path" $depth "$sha1" ||
631 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
635 case "$update_module" in
637 command="git checkout $subforce -q"
638 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
639 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
643 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
644 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
645 must_die_on_failure=yes
649 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
650 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
651 must_die_on_failure=yes
654 command="${update_module#!}"
655 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
656 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
657 must_die_on_failure=yes
660 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
663 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
666 elif test -n "$must_die_on_failure"
668 die_with_status 2 "$die_msg"
670 err="${err};$die_msg"
675 if test -n "$recursive"
678 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
680 sanitize_submodule_env
687 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
690 err="${err};$die_msg"
693 die_with_status $res "$die_msg"
717 # Configures a submodule's default branch
719 # $@ = requested path
729 # we don't do anything with this but we need to accept it
735 case "$2" in '') usage ;; esac
758 # we can't use `git submodule--helper name` here because internally, it
759 # hashes the path so a trailing slash could lead to an unintentional no match
760 name="$(git submodule--helper list "$1" | cut -f2)"
766 test -n "$branch"; has_branch=$?
767 test "$unset_branch" = true; has_unset_branch=$?
769 if test $((!$has_branch != !$has_unset_branch)) -eq 0
774 if test $has_branch -eq 0
776 git submodule--helper config submodule."$name".branch "$branch"
778 git submodule--helper config --unset submodule."$name".branch
783 # Configures a submodule's remote url
785 # $@ = requested path, requested url
808 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper set-url ${GIT_QUIET:+--quiet} -- "$@"
812 # Show commit summary for submodules in index or working tree
814 # If '--cached' is given, show summary between index and given commit,
815 # or between working tree and given commit
817 # $@ = [commit (default 'HEAD'),] requested paths (default all)
824 # parse $args after "submodule ... summary".
839 isnumber "$summary_limit" || usage
843 summary_limit="${1#--summary-limit=}"
844 isnumber "$summary_limit" || usage
860 test $summary_limit = 0 && return
862 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
866 elif test -z "$1" || test "$1" = "HEAD"
868 # before the first commit: compare with an empty tree
869 head=$(git hash-object -w -t tree --stdin </dev/null)
870 test -z "$1" || shift
878 die "$(gettext "The --cached option cannot be used with the --files option")"
884 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
885 # Get modified modules cared by user
886 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
887 sane_egrep '^:([0-7]* )?160000' |
888 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
890 # Always show modules deleted or type-changed (blob<->module)
891 if test "$status" = D || test "$status" = T
893 printf '%s\n' "$sm_path"
896 # Respect the ignore setting for --for-status.
897 if test -n "$for_status"
899 name=$(git submodule--helper name "$sm_path")
900 ignore_config=$(get_submodule_config "$name" ignore none)
901 test $status != A && test $ignore_config = all && continue
903 # Also show added or modified modules which are checked out
904 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
905 printf '%s\n' "$sm_path"
909 test -z "$modules" && return
911 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
912 sane_egrep '^:([0-7]* )?160000' |
914 while read -r mod_src mod_dst sha1_src sha1_dst status name
916 if test -z "$cached" &&
917 is_zero_oid $sha1_dst
921 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
923 100644 | 100755 | 120000)
924 sha1_dst=$(git hash-object $name)
930 eval_gettextln "unexpected mode \$mod_dst" >&2
937 test $mod_src = 160000 &&
938 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
941 test $mod_dst = 160000 &&
942 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
945 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
948 case "$missing_src,$missing_dst" in
950 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
953 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
956 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
961 if test $mod_src = 160000 && test $mod_dst = 160000
963 range="$sha1_src...$sha1_dst"
964 elif test $mod_src = 160000
970 GIT_DIR="$name/.git" \
971 git rev-list --first-parent $range -- | wc -l
973 total_commits=" ($(($total_commits + 0)))"
977 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
978 echo $sha1_src | cut -c1-7)
979 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
980 echo $sha1_dst | cut -c1-7)
984 blob="$(gettext "blob")"
985 submodule="$(gettext "submodule")"
986 if test $mod_dst = 160000
988 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
990 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
993 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
997 # Don't give error msg for modification whose dst is not submodule
998 # i.e. deleted or changed to blob
999 test $mod_dst = 160000 && echo "$errmsg"
1001 if test $mod_src = 160000 && test $mod_dst = 160000
1004 test $summary_limit -gt 0 && limit="-$summary_limit"
1005 GIT_DIR="$name/.git" \
1006 git log $limit --pretty='format: %m %s' \
1007 --first-parent $sha1_src...$sha1_dst
1008 elif test $mod_dst = 160000
1010 GIT_DIR="$name/.git" \
1011 git log --pretty='format: > %s' -1 $sha1_dst
1013 GIT_DIR="$name/.git" \
1014 git log --pretty='format: < %s' -1 $sha1_src
1022 # List all submodules, prefixed with:
1023 # - submodule not initialized
1024 # + different revision checked out
1026 # If --cached was specified the revision in the index will be printed
1027 # instead of the currently checked out revision.
1029 # $@ = requested paths (default to all)
1033 # parse $args after "submodule ... status".
1060 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
1063 # Sync remote urls for submodules
1064 # This makes the value for remote.$remote.url match the value
1065 # specified in .gitmodules.
1093 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
1098 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1101 # This loop parses the command line arguments to find the
1102 # subcommand name to dispatch. Parsing of the subcommand specific
1103 # options are primarily done by the subcommand implementations.
1104 # Subcommand specific options such as --branch and --cached are
1105 # parsed here as well, for backward compatibility.
1107 while test $# != 0 && test -z "$command"
1110 add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
1140 # No command word defaults to "status"
1141 if test -z "$command"
1151 # "-b branch" is accepted only by "add" and "set-branch"
1152 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
1157 # "--cached" is accepted only by "status" and "summary"
1158 if test -n "$cached" && test "$command" != status && test "$command" != summary
1163 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"